# How to use

Hi dear user,

  Currently we have two versions, one is using libusb, which well supported windows, linux, macos, raspi and vocore2, but it consume cpu more or less because it is running on user mode; another version is kernel version, which we have port to voore2(other system will port later), this version runs very fast and stable, but for windows and mac, we need certifacation...for a hobbyist project, that costs too much. Linux system do not have such issue, we will public its driver soon.


## Chnage Log

#### 2018.04.17

- add driver for windows.
- add src/mirror, used to mirror part of your screen to vocore2 screen, depends on Qt to compile.
  

#### 2018.06.11

- add note about using vodisp without admin permission.

#### 2019.03.19

- remove windows demo, please use old version sdk
- add type = djn1522 screen which is little endian, for boost 16bit colors.
- add type = vocore2 screen which is big endian, for boost 24bit colors.


# Quick use for VoCore2

1. first check

If you have VoCore2, you can directly upgrade your firmware to latest version on vocore.io/v2.html. Check if screen works, copy lib/vocore2/vodisp, lib/vocore2/libvodisp.so and img/t1.bmp to your vocore2 /tmp then call "vodisp vocore2 bmp24 /tmp/t1.bmp" to display bitmap on screen. call "vodisp vocore2 test" to test screen colors. vodisp depends on libusb, please install it before test.

note: if you are using djn1522 screen, call "vodisp djn1522 test".

2. run doom on framebuffer.

This test do not need libusb, you can copy lib/vocore2/fbusb.[your device].ko to your vocore2, then "insmod fbusb.[your device].ko", after that, it will create a framebuffer device at /dev/fb0.

Copy DOOM.wad to VoCore2 /tmp/iwad. DOOM.wad can buy from id software. 

Copy src/doom/openwrt/xdoom.vocore2 to /tmp/xdoom.

OK, now we are ready to play. call /tmp/xdoom. I did not finish keyboard
control part, if you like, do your homework, modify src/doom/Source/vo_video.c
to make it work.


# Quick use for Linux

1. Install libusb-1.0 for your linux computer.

For Ubuntu, you can simply call "sudo apt-get install libusb-1.0"

2. Compile vodisp with libvodisp.so, example: "gcc main.c -lvodisp -o vodisp"

3. Create a file /etc/udev/rules.d/98-vocore.rules to enable use vodisp without admin permission.

```
SUBSYSTEM=="usb", ATTRS{idVendor}=="04b4", ATTRS{idProduct}=="8613", MODE="0666"
SUBSYSTEM=="usb", ATTRS{idVendor}=="04b4", ATTRS{idProduct}=="1004", MODE="0666"
```

4. Call "vodisp [screen type]" or "sudo vodisp [screen type]" to enable display libusb mode.

* [screen type] is vocore2 or djn1522.


# Quick use for Windows

1. Install both libusbK driver for windows in demo/win/driver_sleep and driver_normal (please get from old version of sdk, this is removed)

2. You can directly run lib/win/vodisp to boot up the display.


# Quick use for Raspberry Pi

1. Install libusb-1.0 for your raspberry Pi

2. Copy lib/raspi/libvodisp.so to /usr/lib

3. Compile vodisp or directly copy demo/raspi/vodisp to your raspberry Pi

4. Create a file /etc/udev/rules.d/98-vocore.rules to enable use vodisp without admin permission.

```
SUBSYSTEM=="usb", ATTRS{idVendor}=="04b4", ATTRS{idProduct}=="8613", MODE="0666"
SUBSYSTEM=="usb", ATTRS{idVendor}=="04b4", ATTRS{idProduct}=="1004", MODE="0666"
``` 

5. Run "vodisp [screen type]" or "sudo vodisp [screen type]"

* [screen type] is vocore2 or djn1522.

# API

Library libvodisp.so contains all api to use VoCore2 Screen. It depends on
libusb-1.0.so.

- int vodisp_connect([screen type])

Connect to the screen. It will do setting up the screen and display logo. [screen type] is "vocore2" or "djn1522".


- int vodisp_disconnect()

Disconnect from the screen.


- int vodisp_write_frame(const char *buf)

Write data to screen. The buffer size must be FRAMESIZE(1152000), and pixel is
24bits, order is RGBRGBRGB... Screen is 480 x 800.

note: For more API usage such as bitmap 16bit, please check vodisp source code.


# Linux Framebuffer Driver

1. driver is for vocore2, based on linux 4.14
2. driver position is at lib/vocore2
3. we have two version, one is for 'vocore2' screen, another is for 'djn1522' screen, first one is bigendian, for fast 24bit bitmap; second one is little endian, for fast 16bit bitmap(our qt demo video is based on it)
4. call 'insmod fbusb.vocore2.ko' or 'insmod fbusb.djn1522.ko' to enable framebuffer of your screen, the name can be find at back of the screen.
5. when you need to unplug it or reboot your vocore device, call 'echo 1 > /sys/devices/platform/101c0000.ehci/usb1/1-1/1-1:1.0/pause' to disable the screen.

note: this is a kernel bug I think, Linux 4.4 does not have such issue. If you directly unplug screen, kernel will crash.

6. for test, please copy src/doom/openwrt/xdoom.[screen type] to your vocore, and also DOOM.WAD to /tmp, then run on your VoCore2, it is much faster than client mode.
